FLTK 1.4.5: Fl_Table Class Reference

FLTK 1.4.5

Loading...
Searching...
No Matches
Fl_Table Class Reference

A table of widgets or other content. More...

`#include <Fl_Table.H>`

Inheritance diagram for Fl_Table:

## Public Types
enum | TableContext { CONTEXT_NONE = 0 , CONTEXT_STARTPAGE = 0x01 , CONTEXT_ENDPAGE = 0x02 , CONTEXT_ROW_HEADER = 0x04 , CONTEXT_COL_HEADER = 0x08 , CONTEXT_CELL = 0x10 , CONTEXT_TABLE = 0x20 , CONTEXT_RC_RESIZE = 0x40 }
| The context bit flags for Fl_Table related callbacks. More...

## Public Member Functions
void | add (Fl_Widget &wgt)
| The specified widget is removed from its current group (if any) and added to the end of Fl_Table's group.
void | add (Fl_Widget *wgt)
| The specified widget is removed from its current group (if any) and added to the end of Fl_Table's group.
Fl_Widget *const * | array ()
| Returns a pointer to the array of children.
void | begin ()
void | callback (Fl_Widget *, void *)
| Callbacks will be called depending on the setting of Fl_Widget::when().
int | callback_col ()
| Returns the current column the event occurred on.
TableContext | callback_context ()
| Returns the current 'table context'.
int | callback_row ()
| Returns the current row the event occurred on.
Fl_Widget * | child (int n) const
| Returns the child widget by an index.
int | children () const
| Returns the number of children in the table.
virtual void | clear ()
| Clears the table to zero rows (rows(0)), zero columns (cols(0)), and clears any widgets (table->clear()) that were added with begin()/end() or add()/insert()/etc.
int | col_header ()
| Returns if column headers are enabled or not.
void | col_header (int flag)
| Enable or disable column headers.
Fl_Color | col_header_color ()
| Gets the color for column headers.
void | col_header_color (Fl_Color val)
| Sets the color for column headers and redraws the table.
int | col_header_height ()
| Gets the column header height.
void | col_header_height (int height)
| Sets the height in pixels for column headers and redraws the table.
int | col_position ()
| Returns the current column scroll position as a column number.
void | col_position (int col)
| Sets the horizontal scroll position so 'col' is at the left, and causes the screen to redraw.
int | col_resize ()
| Returns if column resizing by the user is allowed.
void | col_resize (int flag)
| Allows/disallows column resizing by the user.
int | col_resize_min ()
| Returns the current column minimum resize value.
void | col_resize_min (int val)
| Sets the current column minimum resize value.
int | col_width (int col)
| Returns the current width of the specified column in pixels.
void | col_width (int col, int width)
| Sets the width of the specified column in pixels, and the table is redrawn.
void | col_width_all (int width)
| Convenience method to set the width of all columns to the same value, in pixels.
int | cols ()
| Get the number of columns in the table.
virtual void | cols (int val)
| Set the number of columns in the table and redraw.
void | do_callback (TableContext context, int row, int col)
| Calls the widget callback.
void | end ()
int | find (const Fl_Widget &wgt) const
int | find (const Fl_Widget *wgt) const
| Fl_Table (int X, int Y, int W, int H, const char *l=0)
| The constructor for Fl_Table.
void | get_selection (int &row_top, int &col_left, int &row_bot, int &col_right) const
| Gets the region of cells selected (highlighted).
void | init_sizes ()
| Resets the internal array of widget sizes and positions.
void | insert (Fl_Widget &wgt, Fl_Widget *w2)
| The specified widget is removed from its current group (if any) and inserted into Fl_Table's group before widget 'w2'.
void | insert (Fl_Widget &wgt, int n)
| The specified widget is removed from its current group (if any) and inserted into the Fl_Table's group at position 'n'.
int | is_interactive_resize ()
| Returns 1 if someone is interactively resizing a row or column.
int | is_selected (int r, int c)
| See if the cell at row `r` and column `c` is selected.
int | move_cursor (int R, int C)
| Same as move_cursor(R,C,1);.
int | move_cursor (int R, int C, int shiftselect)
| Moves the selection cursor a relative number of rows/columns specifed by R/C.
void | remove (Fl_Widget &wgt)
| The specified widget is removed from Fl_Table's group.
void | resize (int X, int Y, int W, int H) FL_OVERRIDE
| Handle resize events if user resizes parent window.
int | row_header ()
| Returns if row headers are enabled or not.
void | row_header (int flag)
| Enables/disables showing the row headers.
Fl_Color | row_header_color ()
| Returns the current row header color.
void | row_header_color (Fl_Color val)
| Sets the row header color and causes the screen to redraw.
int | row_header_width ()
| Returns the current row header width (in pixels).
void | row_header_width (int width)
| Sets the row header width to n and causes the screen to redraw.
int | row_height (int row)
| Returns the current height of the specified row as a value in pixels.
void | row_height (int row, int height)
| Sets the height of the specified row in pixels, and the table is redrawn.
void | row_height_all (int height)
| Convenience method to set the height of all rows to the same value, in pixels.
int | row_position ()
| Returns the current row scroll position as a row number.
void | row_position (int row)
| Sets the vertical scroll position so 'row' is at the top, and causes the screen to redraw.
int | row_resize ()
| Returns if row resizing by the user is allowed.
void | row_resize (int flag)
| Allows/disallows row resizing by the user.
int | row_resize_min ()
| Returns the current row minimum resize value.
void | row_resize_min (int val)
| Sets the current row minimum resize value.
int | rows ()
| Returns the number of rows in the table.
virtual void | rows (int val)
| Sets the number of rows in the table, and the table is redrawn.
int | scrollbar_size () const
| Gets the current size of the scrollbars' troughs, in pixels.
void | scrollbar_size (int newSize)
| Sets the pixel size of the scrollbars' troughs to `newSize`, in pixels.
void | set_selection (int row_top, int col_left, int row_bot, int col_right)
| Sets the region of cells to be selected (highlighted).
int | tab_cell_nav () const
| Get state of table's 'Tab' key cell navigation flag.
void | tab_cell_nav (int val)
| Flag to control if Tab navigates table cells or not.
void | table_box (Fl_Boxtype val)
| Sets the kind of box drawn around the data table, the default being FL_NO_BOX.
Fl_Boxtype | table_box (void)
| Returns the current box type used for the data table.
int | top_row ()
| Returns the current top row shown in the table.
void | top_row (int row)
| Sets which row should be at the top of the table, scrolling as necessary, and the table is redrawn.
void | visible_cells (int &r1, int &r2, int &c1, int &c2)
| Returns the range of row and column numbers for all visible and partially visible cells in the table.
void | when (Fl_When flags)
| The Fl_Widget::when() function is used to set a group of flags, determining when the widget callback is called:
| ~Fl_Table ()
| The destructor for Fl_Table.
Public Member Functions inherited from Fl_Group
Fl_Widget *& | _ddfdesign_kludge ()
| This is for forms compatibility only.
void | add (Fl_Widget &)
| The widget is removed from its current group (if any) and then added to the end of this group.
void | add (Fl_Widget *o)
| See void Fl_Group::add(Fl_Widget &w).
void | add_resizable (Fl_Widget &o)
| Adds a widget to the group and makes it the resizable widget.
Fl_Widget *const * | array () const
| Returns a pointer to the array of children.
Fl_Group const * | as_group () const FL_OVERRIDE
Fl_Group * | as_group () FL_OVERRIDE
| Returns an Fl_Group pointer if this widget is an Fl_Group.
void | begin ()
| Sets the current group so you can build the widget tree by just constructing the widgets.
Fl_Widget * | child (int n) const
| Returns the n'th child.
int | children () const
| Returns how many child widgets the group has.
void | clear ()
| Deletes all child widgets from memory recursively.
unsigned int | clip_children ()
| Returns the current clipping mode.
void | clip_children (int c)
| Controls whether the group widget clips the drawing of child widgets to its bounding box.
virtual int | delete_child (int n)
| Removes the widget at `index` from the group and deletes it.
void | end ()
| Exactly the same as current(this->parent()).
int | find (const Fl_Widget &o) const
| See int Fl_Group::find(const Fl_Widget *w) const.
int | find (const Fl_Widget *) const
| Searches the child array for the widget and returns the index.
| Fl_Group (int, int, int, int, const char *=0)
| Creates a new Fl_Group widget using the given position, size, and label string.
void | focus (Fl_Widget *W)
void | forms_end ()
| This is for forms compatibility only.
void | init_sizes ()
| Resets the internal array of widget sizes and positions.
void | insert (Fl_Widget &, int i)
| The widget is removed from its current group (if any) and then inserted into this group.
void | insert (Fl_Widget &o, Fl_Widget *before)
| This does insert(w, find(before)).
void | remove (Fl_Widget &)
| Removes a widget from the group but does not delete it.
void | remove (Fl_Widget *o)
| Removes the widget `o` from the group.
void | remove (int index)
| Removes the widget at `index` from the group but does not delete it.
Fl_Widget * | resizable () const
| Returns the group's resizable widget.
void | resizable (Fl_Widget &o)
| Sets the group's resizable widget.
void | resizable (Fl_Widget *o)
| The resizable widget defines both the resizing box and the resizing behavior of the group and its children.
virtual | ~Fl_Group ()
| The destructor also deletes all the children.
Public Member Functions inherited from Fl_Widget
void | _clear_fullscreen ()
void | _set_fullscreen ()
void | activate ()
| Activates the widget.
unsigned int | active () const
| Returns whether the widget is active.
int | active_r () const
| Returns whether the widget and all of its parents are active.
Fl_Align | align () const
| Gets the label alignment.
void | align (Fl_Align alignment)
| Sets the label alignment.
long | argument () const
| Gets the current user data (long) argument that is passed to the callback function.
void | argument (long v)
| Sets the current user data (long) argument that is passed to the callback function.
virtual class Fl_Gl_Window * | as_gl_window ()
| Returns an Fl_Gl_Window pointer if this widget is an Fl_Gl_Window.
virtual class Fl_Gl_Window const * | as_gl_window () const
virtual Fl_Window * | as_window ()
| Returns an Fl_Window pointer if this widget is an Fl_Window.
virtual Fl_Window const * | as_window () const
void | bind_deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
void | bind_deimage (int f)
| Bind the inactive image to the widget, so the widget will delete the image when it is no longer needed.
void | bind_image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
void | bind_image (int f)
| Bind the image to the widget, so the widget will delete the image when it is no longer needed.
Fl_Boxtype | box () const
| Gets the box type of the widget.
void | box (Fl_Boxtype new_box)
| Sets the box type for the widget.
Fl_Callback_p | callback () const
| Gets the current callback function for the widget.
void | callback (Fl_Callback *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback *cb, Fl_Callback_User_Data *p, bool auto_free)
| Sets the current callback function and managed user data for the widget.
void | callback (Fl_Callback *cb, void *p)
| Sets the current callback function and data for the widget.
void | callback (Fl_Callback0 *cb)
| Sets the current callback function for the widget.
void | callback (Fl_Callback1 *cb, long p=0)
| Sets the current callback function for the widget.
unsigned int | changed () const
| Checks if the widget value changed since the last callback.
void | clear_active ()
| Marks the widget as inactive without sending events or changing focus.
void | clear_changed ()
| Marks the value of the widget as unchanged.
void | clear_damage (uchar c=0)
| Clears or sets the damage flags.
void | clear_output ()
| Sets a widget to accept input.
void | clear_visible ()
| Hides the widget.
void | clear_visible_focus ()
| Disables keyboard focus navigation with this widget.
Fl_Color | color () const
| Gets the background color of the widget.
void | color (Fl_Color bg)
| Sets the background color of the widget.
void | color (Fl_Color bg, Fl_Color sel)
| Sets the background and selection color of the widget.
Fl_Color | color2 () const
| For back compatibility only.
void | color2 (unsigned a)
| For back compatibility only.
int | contains (const Fl_Widget *w) const
| Checks if w is a child of this widget.
void | copy_label (const char *new_label)
| Sets the current label.
void | copy_tooltip (const char *text)
| Sets the current tooltip text.
uchar | damage () const
| Returns non-zero if draw() needs to be called.
void | damage (uchar c)
| Sets the damage bits for the widget.
void | damage (uchar c, int x, int y, int w, int h)
| Sets the damage bits for an area inside the widget.
int | damage_resize (int, int, int, int)
| Internal use only.
void | deactivate ()
| Deactivates the widget.
Fl_Image * | deimage ()
| Gets the image that is used as part of the widget label when in the inactive state.
const Fl_Image * | deimage () const
| Gets the image that is used as part of the widget label when in the inactive state.
void | deimage (Fl_Image &img)
| Sets the image to use as part of the widget label when in the inactive state.
void | deimage (Fl_Image *img)
| Sets the image to use as part of the widget label when in the inactive state.
int | deimage_bound () const
| Returns whether the inactive image is managed by the widget.
void | do_callback (Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with default arguments.
void | do_callback (Fl_Widget *widget, long arg, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | do_callback (Fl_Widget *widget, void *arg=0, Fl_Callback_Reason reason=FL_REASON_UNKNOWN)
| Calls the widget callback function with arbitrary arguments.
void | draw_label (int, int, int, int, Fl_Align) const
| Draws the label in an arbitrary bounding box with an arbitrary alignment.
int | h () const
| Gets the widget height.
virtual void | hide ()
| Makes a widget invisible.
int | horizontal_label_margin ()
| Get the spacing between the label and the horizontal edge of the widget.
void | horizontal_label_margin (int px)
| Set the spacing between the label and the horizontal edge of the widget.
Fl_Image * | image ()
| Gets the image that is used as part of the widget label when in the active state.
const Fl_Image * | image () const
| Gets the image that is used as part of the widget label when in the active state.
void | image (Fl_Image &img)
| Sets the image to use as part of the widget label when in the active state.
void | image (Fl_Image *img)
| Sets the image to use as part of the widget label when in the active state.
int | image_bound () const
| Returns whether the image is managed by the widget.
int | inside (const Fl_Widget *wgt) const
| Checks if this widget is a child of `wgt`.
int | is_label_copied () const
| Returns whether the current label was assigned with copy_label().
const char * | label () const
| Gets the current label text.
void | label (const char *text)
| Sets the current label pointer.
void | label (Fl_Labeltype a, const char *b)
| Shortcut to set the label text and type in one call.
int | label_image_spacing ()
| Return the gap size between the label and the image.
void | label_image_spacing (int gap)
| Set the gap between the label and the image in pixels.
Fl_Color | labelcolor () const
| Gets the label color.
void | labelcolor (Fl_Color c)
| Sets the label color.
Fl_Font | labelfont () const
| Gets the font to use.
void | labelfont (Fl_Font f)
| Sets the font to use.
Fl_Fontsize | labelsize () const
| Gets the font size in pixels.
void | labelsize (Fl_Fontsize pix)
| Sets the font size in pixels.
Fl_Labeltype | labeltype () const
| Gets the label type.
void | labeltype (Fl_Labeltype a)
| Sets the label type.
void | measure_label (int &ww, int &hh) const
| Sets width ww and height hh accordingly with the label size.
bool | needs_keyboard () const
| Returns whether this widget needs a keyboard.
void | needs_keyboard (bool needs)
| Sets whether this widget needs a keyboard.
unsigned int | output () const
| Returns if a widget is used for output only.
Fl_Group * | parent () const
| Returns a pointer to the parent widget.
void | parent (Fl_Group *p)
| Internal use only - "for hacks only".
void | position (int X, int Y)
| Repositions the window or widget.
void | redraw ()
| Schedules the drawing of the widget.
void | redraw_label ()
| Schedules the drawing of the label.
Fl_Color | selection_color () const
| Gets the selection color.
void | selection_color (Fl_Color a)
| Sets the selection color.
void | set_active ()
| Marks the widget as active without sending events or changing focus.
void | set_changed ()
| Marks the value of the widget as changed.
void | set_output ()
| Sets a widget to output only.
void | set_visible ()
| Makes the widget visible.
void | set_visible_focus ()
| Enables keyboard focus navigation with this widget.
int | shortcut_label () const
| Returns whether the widget's label uses '&' to indicate shortcuts.
void | shortcut_label (int value)
| Sets whether the widget's label uses '&' to indicate shortcuts.
virtual void | show ()
| Makes a widget visible.
void | size (int W, int H)
| Changes the size of the widget.
int | take_focus ()
| Gives the widget the keyboard focus.
unsigned int | takesevents () const
| Returns if the widget is able to take events.
int | test_shortcut ()
| Returns true if the widget's label contains the entered '&x' shortcut.
const char * | tooltip () const
| Gets the current tooltip text.
void | tooltip (const char *text)
| Sets the current tooltip text.
Fl_Window * | top_window () const
| Returns a pointer to the top-level window for the widget.
Fl_Window * | top_window_offset (int &xoff, int &yoff) const
| Finds the x/y offset of the current widget relative to the top-level window.
uchar | type () const
| Gets the widget type.
void | type (uchar t)
| Sets the widget type.
int | use_accents_menu ()
| Returns non zero if MAC_USE_ACCENTS_MENU flag is set, 0 otherwise.
void * | user_data () const
| Gets the user data for this widget.
void | user_data (Fl_Callback_User_Data *v, bool auto_free)
| Sets the user data for this widget.
void | user_data (void *v)
| Sets the user data for this widget.
int | vertical_label_margin ()
| Get the spacing between the label and the vertical edge of the widget.
void | vertical_label_margin (int px)
| Set the spacing between the label and the vertical edge of the widget.
unsigned int | visible () const
| Returns whether a widget is visible.
unsigned int | visible_focus () const
| Checks whether this widget has a visible focus.
void | visible_focus (int v)
| Modifies keyboard focus navigation.
int | visible_r () const
| Returns whether a widget and all its parents are visible.
int | w () const
| Gets the widget width.
Fl_When | when () const
| Returns the conditions under which the callback is called.
void | when (uchar i)
| Sets the flags used to decide when a callback is called.
Fl_Window * | window () const
| Returns a pointer to the nearest parent window up the widget hierarchy.
int | x () const
| Gets the widget position in its window.
int | y () const
| Gets the widget position in its window.
virtual | ~Fl_Widget ()
| Destroys the widget.

## Protected Types
enum | ResizeFlag { RESIZE_NONE = 0 , RESIZE_COL_LEFT = 1 , RESIZE_COL_RIGHT = 2 , RESIZE_ROW_ABOVE = 3 , RESIZE_ROW_BELOW = 4 }
Protected Types inherited from Fl_Widget
enum | { INACTIVE = 1<<0 , INVISIBLE = 1<<1 , OUTPUT = 1<<2 , NOBORDER = 1<<3 , FORCE_POSITION = 1<<4 , NON_MODAL = 1<<5 , SHORTCUT_LABEL = 1<<6 , CHANGED = 1<<7 , OVERRIDE = 1<<8 , VISIBLE_FOCUS = 1<<9 , COPIED_LABEL = 1<<10 , CLIP_CHILDREN = 1<<11 , MENU_WINDOW = 1<<12 , TOOLTIP_WINDOW = 1<<13 , MODAL = 1<<14 , NO_OVERLAY = 1<<15 , GROUP_RELATIVE = 1<<16 , COPIED_TOOLTIP = 1<<17 , FULLSCREEN = 1<<18 , MAC_USE_ACCENTS_MENU = 1<<19 , NEEDS_KEYBOARD = 1<<20 , IMAGE_BOUND = 1<<21 , DEIMAGE_BOUND = 1<<22 , AUTO_DELETE_USER_DATA = 1<<23 , MAXIMIZED = 1<<24 , POPUP = 1<<25 , USERFLAG3 = 1<<29 , USERFLAG2 = 1<<30 , USERFLAG1 = 1<<31 }
| flags possible values enumeration. More...

## Protected Member Functions
void | change_cursor (Fl_Cursor newcursor)
| Change mouse cursor to different type.
long | col_scroll_position (int col)
| Returns the scroll position (in pixels) of the specified column 'col'.
TableContext | cursor2rowcol (int &R, int &C, ResizeFlag &resizeflag)
| Find row/col for the recent mouse event.
void | damage_zone (int r1, int c1, int r2, int c2, int r3=0, int c3=0)
| Sets the damage zone to the specified row/col values.
void | draw () FL_OVERRIDE
| Draws the entire Fl_Table.
virtual void | draw_cell (TableContext context, int R=0, int C=0, int X=0, int Y=0, int W=0, int H=0)
| Subclass should override this method to handle drawing the cells.
int | find_cell (TableContext context, int R, int C, int &X, int &Y, int &W, int &H)
| Find a cell's X/Y/W/H region for the specified cell in row 'R', column 'C'.
void | get_bounds (TableContext context, int &X, int &Y, int &W, int &H)
| Returns the (X,Y,W,H) bounding region for the specified 'context'.
int | handle (int e) FL_OVERRIDE
| Handle FLTK events.
int | is_fltk_container ()
| Does the table contain any child fltk widgets?
void | recalc_dimensions ()
| Recalculate the dimensions of the table, and affect any children.
void | redraw_range (int topRow, int botRow, int leftCol, int rightCol)
| Define region of cells to be redrawn by specified range of rows/cols, and then sets damage(DAMAGE_CHILD).
int | row_col_clamp (TableContext context, int &R, int &C)
| Return specified row/col values R and C to within the table's current row/col limits.
long | row_scroll_position (int row)
| Returns the scroll position (in pixels) of the specified 'row'.
void | table_resized ()
| Call this if table was resized, to recalculate internal data.
void | table_scrolled ()
| Recalculate internals after a scroll.
Protected Member Functions inherited from Fl_Group
Fl_Rect * | bounds ()
| Returns the internal array of widget sizes and positions.
void | draw_child (Fl_Widget &widget) const
| Forces a child to redraw.
void | draw_children ()
| Draws all children of the group.
void | draw_outside_label (const Fl_Widget &widget) const
| Parents normally call this to draw outside labels of child widgets.
virtual int | on_insert (Fl_Widget *, int)
| Allow derived groups to act when a widget is added as a child.
virtual int | on_move (int, int)
| Allow derived groups to act when a widget is moved within the group.
virtual void | on_remove (int)
| Allow derived groups to act when a child widget is removed from the group.
int * | sizes ()
| Returns the internal array of widget sizes and positions.
void | update_child (Fl_Widget &widget) const
| Draws a child only if it needs it.
Protected Member Functions inherited from Fl_Widget
void | clear_flag (unsigned int c)
| Clears a flag in the flags mask.
void | draw_backdrop () const
| If FL_ALIGN_IMAGE_BACKDROP is set, the image or deimage will be drawn.
void | draw_box () const
| Draws the widget box according its box style.
void | draw_box (Fl_Boxtype t, Fl_Color c) const
| Draws a box of type t, of color c at the widget's position and size.
void | draw_box (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color c) const
| Draws a box of type t, of color c at the position X,Y and size W,H.
void | draw_focus () const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int X, int Y, int W, int H) const
| Draws a focus rectangle around the widget.
void | draw_focus (Fl_Boxtype t, int x, int y, int w, int h, Fl_Color bg) const
| Draws a focus box for the widget at the given position and size.
void | draw_label () const
| Draws the widget's label at the defined label position.
void | draw_label (int, int, int, int) const
| Draws the label in an arbitrary bounding box.
| Fl_Widget (int x, int y, int w, int h, const char *label=0L)
| Creates a widget at the given position and size.
unsigned int | flags () const
| Gets the widget flags mask.
void | h (int v)
| Internal use only.
void | set_flag (unsigned int c)
| Sets a flag in the flags mask.
void | w (int v)
| Internal use only.
void | x (int v)
| Internal use only.
void | y (int v)
| Internal use only.

## Static Protected Member Functions
static void | scroll_cb (Fl_Widget *, void *)
| Callback for when someone moves a scrollbar.

## Protected Attributes
int | botrow
| bottom row# of currently visible table on screen
int | current_col
| selection cursor's current column (-1 if none)
int | current_row
| selection cursor's current row (-1 if none)
Fl_Scrollbar * | hscrollbar
| child horizontal scrollbar widget
int | leftcol
| left column# of currently visible table on screen
int | leftcol_scrollpos
| precomputed scroll position for left column
int | rightcol
| right column# of currently visible table on screen
int | select_col
| extended selection column (-1 if none)
int | select_row
| extended selection row (-1 if none)
Fl_Scroll * | table
| child Fl_Scroll widget container for child fltk widgets (if any)
int | table_h
| table's virtual height (in pixels)
int | table_w
| table's virtual width (in pixels)
int | tih
| Data table's inner h dimension, inside bounding box. See Table Dimension Diagram.
int | tiw
| Data table's inner w dimension, inside bounding box. See Table Dimension Diagram.
int | tix
| Data table's inner x dimension, inside bounding box. See Table Dimension Diagram.
int | tiy
| Data table's inner y dimension, inside bounding box. See Table Dimension Diagram.
int | toh
| Data table's outer h dimension, outside bounding box. See Table Dimension Diagram.
int | toprow
| top row# of currently visible table on screen
int | toprow_scrollpos
| precomputed scroll position for top row
int | tow
| Data table's outer w dimension, outside bounding box. See Table Dimension Diagram.
int | tox
| Data table's outer x dimension, outside bounding box. See Table Dimension Diagram.
int | toy
| Data table's outer y dimension, outside bounding box. See Table Dimension Diagram.
Fl_Scrollbar * | vscrollbar
| child vertical scrollbar widget
int | wih
| Table widget's inner h dimension, inside bounding box. See Table Dimension Diagram.
int | wiw
| Table widget's inner w dimension, inside bounding box. See Table Dimension Diagram.
int | wix
| Table widget's inner x dimension, inside bounding box. See Table Dimension Diagram.
int | wiy
| Table widget's inner y dimension, inside bounding box. See Table Dimension Diagram.

## Additional Inherited Members
Static Public Member Functions inherited from Fl_Group
static Fl_Group * | current ()
| Returns the currently active group.
static void | current (Fl_Group *g)
| Sets the current group.
Static Public Member Functions inherited from Fl_Widget
static void | default_callback (Fl_Widget *widget, void *data)
| The default callback for all widgets that don't set a callback.
static unsigned int | label_shortcut (const char *t)
| Returns the Unicode value of the '&x' shortcut in a given text.
static int | test_shortcut (const char *, const bool require_alt=false)
| Returns true if the given text `t` contains the entered '&x' shortcut.

## Detailed Description

A table of widgets or other content.

This is the base class for table widgets.

To be useful it must be subclassed and several virtual functions defined. Normally applications use widgets derived from this widget, and do not use this widget directly; this widget is usually too low level to be used directly by applications.

This widget does not handle the data in the table. The draw_cell() method must be overridden by a subclass to manage drawing the contents of the cells.

This widget can be used in several ways:

- As a custom widget; see examples/table-simple.cxx and test/table.cxx. Very optimal for even extremely large tables.
- As a table made up of a single FLTK widget instanced all over the table, simulating a numeric spreadsheet. See examples/table-spreadsheet.cxx and examples/table-spreadsheet-with-keyboard-nav.cxx. Optimal for large tables.
- As a regular container of FLTK widgets, one widget per cell. See examples/table-as-container.cxx. Not recommended for large tables.

When acting as part of a custom widget, events on the cells and/or headings generate callbacks when they are clicked by the user. You control when events are generated based on the setting for Fl_Table::when().

When acting as a container for FLTK widgets, the FLTK widgets maintain themselves. Although the draw_cell() method must be overridden, its contents can be very simple. See the draw_cell() code in examples/table-simple.cxx.

The following variables are available to classes deriving from Fl_Table:

x()/y()/w()/h() | Fl_Table widget's outer dimension. The outer edge of the border of the Fl_Table. (Red in the diagram above)
wix/wiy/wiw/wih | Fl_Table widget's inner dimension. The inner edge of the border of the Fl_Table. eg. if the Fl_Table's box() is FL_NO_BOX, these values are the same as x()/y()/w()/h(). (Yellow in the diagram above)
tox/toy/tow/toh | The table's outer dimension. The outer edge of the border around the cells, but inside the row/col headings and scrollbars. (Green in the diagram above)
tix/tiy/tiw/tih | The table's inner dimension. The inner edge of the border around the cells, but inside the row/col headings and scrollbars. AKA the table's clip region. eg. if the table_box() is FL_NO_BOX, these values are the same as tox/toy/tow/toh. (Blue in the diagram above)

CORE DEVELOPERS

- Greg Ercolano : 12/16/2002 - initial implementation 12/16/02. Fl_Table, Fl_Table_Row, docs.
- Jean-Marc Lienher : 02/22/2004 - added keyboard nav + mouse selection, and ported Fl_Table into fltk-utf8-1.1.4

OTHER CONTRIBUTORS

- Inspired by the Feb 2000 version of FLVW's Flvw_Table widget. Mucho thanks to those folks.
- Mister Satan : 04/07/2003 - MinGW porting mods, and singleinput.cxx; a cool Fl_Input oriented spreadsheet example
- Marek Paliwoda : 01/08/2003 - Porting mods for Borland
- Ori Berger : 03/16/2006 - Optimizations for >500k rows/cols

LICENSE

Greg kindly gave his permission to integrate Fl_Table and Fl_Table_Row into FLTK, allowing FLTK license to apply while his widgets are part of the library. [updated by Greg, 04/26/17]

## Member Enumeration Documentation

## ◆ TableContext

enum Fl_Table::TableContext

The context bit flags for Fl_Table related callbacks.

Should be used in draw_cell() to determine what's being drawn, or in a callback() to determine where a recent event occurred.

Enumerator
CONTEXT_NONE | no known context
CONTEXT_STARTPAGE | before the table is redrawn
CONTEXT_ENDPAGE | after the table is redrawn
CONTEXT_ROW_HEADER | drawing or event occurred in the row header
CONTEXT_COL_HEADER | drawing or event occurred in the col header
CONTEXT_CELL | drawing or event occurred in a cell
CONTEXT_TABLE | drawing or event occurred in a dead zone of table
CONTEXT_RC_RESIZE | column or row is being resized

## Constructor & Destructor Documentation

## ◆ Fl_Table()

Fl_Table::Fl_Table | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H,
|  | const char * | l = 0 )

The constructor for Fl_Table.

This creates an empty table with no rows or columns, with headers and row/column resize behavior disabled.

## ◆ ~Fl_Table()

Fl_Table::~Fl_Table | ( |  | ) |

The destructor for Fl_Table.

Destroys the table and its associated widgets.

## Member Function Documentation

## ◆ array()

Fl_Widget *const * Fl_Table::array | ( |  | ) |
| inline

Returns a pointer to the array of children.

This pointer is only valid until the next time a child is added or removed.

## ◆ callback()

void Fl_Table::callback | ( | Fl_Widget * | ,
|  | void * | )

Callbacks will be called depending on the setting of Fl_Widget::when().

Callback functions should use the following functions to determine the context/row/column:

- Fl_Table::callback_row() returns current row
- Fl_Table::callback_col() returns current column
- Fl_Table::callback_context() returns current table context

callback_row() and callback_col() will be set to the row and column number the event occurred on. If someone clicked on a row header, `col` will be 0. If someone clicked on a column header, `row` will be 0.

callback_context() will return one of the following:

Fl_Table::CONTEXT_ROW_HEADER | Someone clicked on a row header. Excludes resizing.
Fl_Table::CONTEXT_COL_HEADER | Someone clicked on a column header. Excludes resizing.
Fl_Table::CONTEXT_CELL | Someone clicked on a cell. To receive callbacks for FL_RELEASE events, you must set when(FL_WHEN_RELEASE).
Fl_Table::CONTEXT_RC_RESIZE | Someone is resizing rows/columns either interactively, or via the col_width() or row_height() API. Use is_interactive_resize() to determine interactive resizing. If resizing a column, R=0 and C=column being resized. If resizing a row, C=0 and R=row being resized. NOTE: To receive resize events, you must set when(FL_WHEN_CHANGED).

class MyTable : public Fl_Table {
[..]
private:
// Handle events that happen on the table
void event_callback2() {
int R = callback_row(), // row where event occurred
C = callback_col(); // column where event occurred
TableContext context = callback_context(); // which part of table
fprintf(stderr, "callback: Row=%d Col=%d Context=%d Event=%d\n",
R, C, (int)context, (int)Fl::event());
}
// Actual static callback
static void event_callback(Fl_Widget*, void* data) {
MyTable *o = (MyTable*)data;
o->event_callback2();
}
public:
// Constructor
MyTable() {
[..]
table.callback(&event_callback, (void*)this); // setup callback
table.when(FL_WHEN_CHANGED|FL_WHEN_RELEASE); // when to call it
}
};
FL_WHEN_CHANGED
@ FL_WHEN_CHANGED
Do the callback only when the widget value changes.
Definition Enumerations.H:437
FL_WHEN_RELEASE
@ FL_WHEN_RELEASE
Do the callback when the button or key is released and the value changes.
Definition Enumerations.H:439
Fl_Table::callback_col
int callback_col()
Returns the current column the event occurred on.
Definition Fl_Table.H:899
Fl_Table::callback_row
int callback_row()
Returns the current row the event occurred on.
Definition Fl_Table.H:890
Fl_Table::callback_context
TableContext callback_context()
Returns the current 'table context'.
Definition Fl_Table.H:908
Fl_Table::TableContext
TableContext
The context bit flags for Fl_Table related callbacks.
Definition Fl_Table.H:129
Fl_Table::Fl_Table
Fl_Table(int X, int Y, int W, int H, const char *l=0)
The constructor for Fl_Table.
Definition Fl_Table.cxx:119
Fl_Widget
Fl_Widget is the base class for all widgets in FLTK.
Definition Fl_Widget.H:112
Fl::event
static int event()
Returns the last event that was processed.
Definition Fl.H:626

## ◆ callback_col()

int Fl_Table::callback_col | ( |  | ) |
| inline

Returns the current column the event occurred on.

This function should only be used from within the user's callback function.

## ◆ callback_context()

TableContext Fl_Table::callback_context | ( |  | ) |
| inline

Returns the current 'table context'.

This function should only be used from within the user's callback function.

## ◆ callback_row()

int Fl_Table::callback_row | ( |  | ) |
| inline

Returns the current row the event occurred on.

This function should only be used from within the user's callback function.

## ◆ child()

Fl_Widget * Fl_Table::child | ( | int | n | ) | const
| inline

Returns the child widget by an index.

When using the Fl_Table as a container for FLTK widgets, this method returns the widget pointer from the internal array of widgets in the container.

Typically used in loops, eg:

for ( int i=0; i<children(); i++ ) {
Fl_Widget *w = child(i);
[..]
}
Fl_Table::children
int children() const
Returns the number of children in the table.
Definition Fl_Table.H:869
Fl_Table::child
Fl_Widget * child(int n) const
Returns the child widget by an index.
Definition Fl_Table.H:857
Fl_Widget::w
void w(int v)
Internal use only.
Definition Fl_Widget.H:154

## ◆ children()

int Fl_Table::children | ( |  | ) | const
| inline

Returns the number of children in the table.

When using the Fl_Table as a container for FLTK widgets, this method returns how many child widgets the table has.

See also
  child(int)

## ◆ clear()

virtual void Fl_Table::clear | ( |  | ) |
| inlinevirtual

Clears the table to zero rows (rows(0)), zero columns (cols(0)), and clears any widgets (table->clear()) that were added with begin()/end() or add()/insert()/etc.

See also
  rows(int), cols(int)

Reimplemented in Fl_Table_Row.

## ◆ col_header()

void Fl_Table::col_header | ( | int | flag | ) |
| inline

Enable or disable column headers.

If changed, the table is redrawn.

## ◆ col_resize()

void Fl_Table::col_resize | ( | int | flag | ) |
| inline

Allows/disallows column resizing by the user.

1=allow interactive resizing, 0=disallow interactive resizing. Since interactive resizing is done via the column headers, `col_header()` must also be enabled to allow resizing.

## ◆ col_resize_min()

void Fl_Table::col_resize_min | ( | int | val | ) |
| inline

Sets the current column minimum resize value.

This is used to prevent the user from interactively resizing any column to be smaller than 'pixels'. Must be a value >=1.

## ◆ col_width()

void Fl_Table::col_width | ( | int | col,
|  | int | width )

Sets the width of the specified column in pixels, and the table is redrawn.

callback() will be invoked with CONTEXT_RC_RESIZE if the column's width was actually changed, and when() is FL_WHEN_CHANGED.

## ◆ col_width_all()

void Fl_Table::col_width_all | ( | int | width | ) |
| inline

Convenience method to set the width of all columns to the same value, in pixels.

The screen is redrawn.

## ◆ cursor2rowcol()

Fl_Table::TableContext Fl_Table::cursor2rowcol | ( | int & | R,
|  | int & | C,
|  | ResizeFlag & | resizeflag )
| protected

Find row/col for the recent mouse event.

Returns the context, and the row/column values in R/C. Also returns 'resizeflag' if mouse is hovered over a resize boundary.

## ◆ damage_zone()

void Fl_Table::damage_zone | ( | int | r1,
|  | int | c1,
|  | int | r2,
|  | int | c2,
|  | int | r3 = 0,
|  | int | c3 = 0 )
| protected

Sets the damage zone to the specified row/col values.

Calls redraw_range().

## ◆ do_callback()

void Fl_Table::do_callback | ( | TableContext | context,
|  | int | row,
|  | int | col )
| inline

Calls the widget callback.

Saves the specified 'context', 'row', and 'col' values, so that the user's callback can then access them with the member functions callback_context(), callback_row() and callback_col().

## ◆ draw()

void Fl_Table::draw | ( | void |  | ) |
| protectedvirtual

Draws the entire Fl_Table.

Lets fltk widgets draw themselves first, followed by the cells via calls to draw_cell().

Reimplemented from Fl_Group.

## ◆ draw_cell()

virtual void Fl_Table::draw_cell | ( | TableContext | context,
|  | int | R = 0,
|  | int | C = 0,
|  | int | X = 0,
|  | int | Y = 0,
|  | int | W = 0,
|  | int | H = 0 )
| inlineprotectedvirtual

Subclass should override this method to handle drawing the cells.

This method will be called whenever the table is redrawn, once per cell.

Only cells that are completely (or partially) visible will be told to draw.

`context` will be one of the following:

`Fl_Table::CONTEXT_STARTPAGE` | When table, or parts of the table, are about to be redrawn. Use to initialize static data, such as font selections. R/C will be zero, X/Y/W/H will be the dimensions of the table's entire data area. (Useful for locking a database before accessing; see also visible_cells())
`Fl_Table::CONTEXT_ENDPAGE` | When table has completed being redrawn. R/C will be zero, X/Y/W/H dimensions of table's data area. (Useful for unlocking a database after accessing)
`Fl_Table::CONTEXT_ROW_HEADER` | Whenever a row header cell needs to be drawn. R will be the row number of the header being redrawn, C will be zero, X/Y/W/H will be the fltk drawing area of the row header in the window
`Fl_Table::CONTEXT_COL_HEADER` | Whenever a column header cell needs to be drawn. R will be zero, C will be the column number of the header being redrawn, X/Y/W/H will be the fltk drawing area of the column header in the window
`Fl_Table::CONTEXT_CELL` | Whenever a data cell in the table needs to be drawn. R/C will be the row/column of the cell to be drawn, X/Y/W/H will be the fltk drawing area of the cell in the window
`Fl_Table::CONTEXT_RC_RESIZE` | Whenever table or row/column is resized or scrolled, either interactively or via col_width() or row_height(). R/C/X/Y/W/H will all be zero. Useful for fltk containers that need to resize or move the child fltk widgets.

`R` and `C` will be set to the row and column number of the cell being drawn. In the case of row headers, `C` will be 0. In the case of column headers, `R` will be 0.

X/Y/W/H will be the position and dimensions of where the cell should be drawn.

In the case of custom widgets, a minimal draw_cell() override might look like the following. With custom widgets it is up to the caller to handle drawing everything within the dimensions of the cell, including handling the selection color. Note all clipping must be handled as well; this allows drawing outside the dimensions of the cell if so desired for 'custom effects'.

// This is called whenever Fl_Table wants you to draw a cell
void MyTable::draw_cell(TableContext context, int R=0, int C=0, int X=0, int Y=0, int W=0, int H=0) {
static char s[40];
sprintf(s, "%d/%d", R, C); // text for each cell
switch ( context ) {
case CONTEXT_STARTPAGE: // Fl_Table telling us it's starting to draw page
fl_font(FL_HELVETICA, 16);
return;
case CONTEXT_ROW_HEADER: // Fl_Table telling us to draw row/col headers
case CONTEXT_COL_HEADER:
fl_push_clip(X, Y, W, H);
{
fl_draw_box(FL_THIN_UP_BOX, X, Y, W, H, color());
fl_color(FL_BLACK);
fl_draw(s, X, Y, W, H, FL_ALIGN_CENTER);
}
fl_pop_clip();
return;
case CONTEXT_CELL: // Fl_Table telling us to draw cells
fl_push_clip(X, Y, W, H);
{
// BG COLOR
fl_color(is_selected(R, C) ? selection_color() : FL_WHITE);
fl_rectf(X, Y, W, H);
// TEXT
fl_color(FL_BLACK);
fl_draw(s, X, Y, W, H, FL_ALIGN_CENTER);
// BORDER
fl_color(FL_LIGHT2);
fl_rect(X, Y, W, H);
}
fl_pop_clip();
return;
default:
return;
}
//NOTREACHED
}
FL_ALIGN_CENTER
const Fl_Align FL_ALIGN_CENTER
Align the label horizontally in the middle.
Definition Enumerations.H:989
FL_HELVETICA
const Fl_Font FL_HELVETICA
Helvetica (or Arial) normal (0).
Definition Enumerations.H:1065
FL_THIN_UP_BOX
@ FL_THIN_UP_BOX
see figure Standard Box Types
Definition Enumerations.H:652
Fl_Table::is_selected
int is_selected(int r, int c)
See if the cell at row r and column c is selected.
Definition Fl_Table.cxx:1218
Fl_Table::CONTEXT_COL_HEADER
@ CONTEXT_COL_HEADER
drawing or event occurred in the col header
Definition Fl_Table.H:134
Fl_Table::CONTEXT_STARTPAGE
@ CONTEXT_STARTPAGE
before the table is redrawn
Definition Fl_Table.H:131
Fl_Table::CONTEXT_ROW_HEADER
@ CONTEXT_ROW_HEADER
drawing or event occurred in the row header
Definition Fl_Table.H:133
Fl_Table::CONTEXT_CELL
@ CONTEXT_CELL
drawing or event occurred in a cell
Definition Fl_Table.H:135
Fl_Widget::color
Fl_Color color() const
Gets the background color of the widget.
Definition Fl_Widget.H:455
Fl_Widget::selection_color
Fl_Color selection_color() const
Gets the selection color.
Definition Fl_Widget.H:473
fl_font
Fl_Font fl_font()
Return the face set by the most recent call to fl_font().
Definition fl_draw.H:811
fl_color
Fl_Color fl_color()
Return the last fl_color() that was set.
Definition fl_draw.H:74
fl_rectf
void fl_rectf(int x, int y, int w, int h)
Color with current color a rectangle that exactly fills the given bounding box.
Definition fl_draw.H:339
fl_draw
void fl_draw(const char *str, int x, int y)
Draw a nul-terminated UTF-8 string starting at the given x, y location.
Definition fl_font.cxx:32
fl_rect
void fl_rect(int x, int y, int w, int h)
Draw a border inside the given bounding box.
Definition fl_draw.H:298
fl_pop_clip
void fl_pop_clip()
Restore the previous clip region.
Definition fl_draw.H:115
fl_push_clip
void fl_push_clip(int x, int y, int w, int h)
Intersect the current clip region with a rectangle and push this new region onto the stack.
Definition fl_draw.H:88
fl_draw_box
void fl_draw_box(Fl_Boxtype, int x, int y, int w, int h, Fl_Color)
Draws a box using given type, position, size and color.
Definition fl_boxtype.cxx:471

## ◆ find_cell()

int Fl_Table::find_cell | ( | TableContext | context,
|  | int | R,
|  | int | C,
|  | int & | X,
|  | int & | Y,
|  | int & | W,
|  | int & | H )
| protected

Find a cell's X/Y/W/H region for the specified cell in row 'R', column 'C'.

Returns
  - 0 – on success, XYWH returns the region of the specified cell.
  - -1 – if R or C are out of range, and X/Y/W/H will be set to zero.

## ◆ get_selection()

void Fl_Table::get_selection | ( | int & | row_top,
|  | int & | col_left,
|  | int & | row_bot,
|  | int & | col_right ) const

Gets the region of cells selected (highlighted).

Parameters

  [in] | row_top | Returns the top row of selection area
  [in] | col_left | Returns the left column of selection area
  [in] | row_bot | Returns the bottom row of selection area
  [in] | col_right | Returns the right column of selection area

## ◆ handle()

int Fl_Table::handle | ( | int | e | ) |
| protectedvirtual

Handle FLTK events.

Reimplemented from Fl_Group.

Reimplemented in Fl_Table_Row.

## ◆ init_sizes()

void Fl_Table::init_sizes | ( |  | ) |
| inline

Resets the internal array of widget sizes and positions.

See also
  Fl_Group::init_sizes()

## ◆ insert()

void Fl_Table::insert | ( | Fl_Widget & | wgt,
|  | Fl_Widget * | w2 )
| inline

The specified widget is removed from its current group (if any) and inserted into Fl_Table's group before widget 'w2'.

This will append if 'w2' is not in Fl_Table's group.

## ◆ is_interactive_resize()

int Fl_Table::is_interactive_resize | ( |  | ) |
| inline

Returns 1 if someone is interactively resizing a row or column.

You can currently call this only from within your callback().

## ◆ is_selected()

int Fl_Table::is_selected | ( | int | r,
|  | int | c )

See if the cell at row `r` and column `c` is selected.

Returns
  1 if the cell is selected, 0 if not.

## ◆ move_cursor()

int Fl_Table::move_cursor | ( | int | R,
|  | int | C,
|  | int | shiftselect )

Moves the selection cursor a relative number of rows/columns specifed by R/C.

R/C can be positive or negative, depending on the direction to move. A value of 0 for R or C prevents cursor movement on that axis.

If shiftselect is set, the selection range is extended to the new cursor position. If clear, the cursor is simply moved, and any previous selection is cancelled.

Used mainly by keyboard events (e.g. Fl_Right, FL_Home, FL_End..) to let the user keyboard navigate the selection cursor around.

The scroll positions may be modified if the selection cursor traverses into cells off the screen's edge.

Internal variables select_row/select_col and current_row/current_col are modified, among others.

Examples:
R=1, C=0 -- moves the selection cursor one row downward.
R=5, C=0 -- moves the selection cursor 5 rows downward.
R=-5, C=0 -- moves the cursor 5 rows upward.
R=2, C=2 -- moves the cursor 2 rows down and 2 columns to the right.
Fl_Table::rows
virtual void rows(int val)
Sets the number of rows in the table, and the table is redrawn.
Definition Fl_Table.cxx:686

## ◆ recalc_dimensions()

void Fl_Table::recalc_dimensions | ( |  | ) |
| protected

Recalculate the dimensions of the table, and affect any children.

Internally, Fl_Group::resize() and init_sizes() are called.

## ◆ redraw_range()

void Fl_Table::redraw_range | ( | int | topRow,
|  | int | botRow,
|  | int | leftCol,
|  | int | rightCol )
| inlineprotected

Define region of cells to be redrawn by specified range of rows/cols, and then sets damage(DAMAGE_CHILD).

Extends any previously defined range to redraw.

## ◆ resize()

void Fl_Table::resize | ( | int | X,
|  | int | Y,
|  | int | W,
|  | int | H )
| virtual

Handle resize events if user resizes parent window.

This changes the size of Fl_Table, causing it to redraw.

Reimplemented from Fl_Group.

## ◆ row_col_clamp()

int Fl_Table::row_col_clamp | ( | TableContext | context,
|  | int & | R,
|  | int & | C )
| protected

Return specified row/col values R and C to within the table's current row/col limits.

Returns
  0 if no changes were made, or 1 if they were.

## ◆ row_header()

void Fl_Table::row_header | ( | int | flag | ) |
| inline

Enables/disables showing the row headers.

1=enabled, 0=disabled. If changed, the table is redrawn.

## ◆ row_height()

void Fl_Table::row_height | ( | int | row,
|  | int | height )

Sets the height of the specified row in pixels, and the table is redrawn.

callback() will be invoked with CONTEXT_RC_RESIZE if the row's height was actually changed, and when() is FL_WHEN_CHANGED.

## ◆ row_height_all()

void Fl_Table::row_height_all | ( | int | height | ) |
| inline

Convenience method to set the height of all rows to the same value, in pixels.

The screen is redrawn.

## ◆ row_resize()

void Fl_Table::row_resize | ( | int | flag | ) |
| inline

Allows/disallows row resizing by the user.

1=allow interactive resizing, 0=disallow interactive resizing. Since interactive resizing is done via the row headers, row_header() must also be enabled to allow resizing.

## ◆ row_resize_min()

void Fl_Table::row_resize_min | ( | int | val | ) |
| inline

Sets the current row minimum resize value.

This is used to prevent the user from interactively resizing any row to be smaller than 'pixels'. Must be a value >=1.

## ◆ rows()

void Fl_Table::rows | ( | int | val | ) |
| virtual

Sets the number of rows in the table, and the table is redrawn.

Reimplemented in Fl_Table_Row.

## ◆ scrollbar_size() [1/2]

int Fl_Table::scrollbar_size | ( |  | ) | const
| inline

Gets the current size of the scrollbars' troughs, in pixels.

If this value is zero (default), this widget will use the Fl::scrollbar_size() value as the scrollbar's width.

Returns
  Scrollbar size in pixels, or 0 if the global Fl::scrollbar_size() is being used.

See also
  Fl::scrollbar_size(int)

## ◆ scrollbar_size() [2/2]

void Fl_Table::scrollbar_size | ( | int | newSize | ) |
| inline

Sets the pixel size of the scrollbars' troughs to `newSize`, in pixels.

Normally you should not need this method, and should use Fl::scrollbar_size(int) instead to manage the size of ALL your widgets' scrollbars. This ensures your application has a consistent UI, is the default behavior, and is normally what you want.

Only use THIS method if you really need to override the global scrollbar size. The need for this should be rare.

Setting `newSize` to the special value of 0 causes the widget to track the global Fl::scrollbar_size(), which is the default.

Parameters

  [in] | newSize | Sets the scrollbar size in pixels. If 0 (default), scrollbar size tracks the global Fl::scrollbar_size()

See also
  Fl::scrollbar_size()

## ◆ set_selection()

void Fl_Table::set_selection | ( | int | row_top,
|  | int | col_left,
|  | int | row_bot,
|  | int | col_right )

Sets the region of cells to be selected (highlighted).

So for instance, set_selection(0,0,0,0) selects the top/left cell in the table. And set_selection(0,0,1,1) selects the four cells in rows 0 and 1, column 0 and 1.

To deselect all cells, use set_selection(-1,-1,-1,-1);

Parameters

  [in] | row_top | Top row of selection area
  [in] | col_left | Left column of selection area
  [in] | row_bot | Bottom row of selection area
  [in] | col_right | Right column of selection area

## ◆ tab_cell_nav() [1/2]

int Fl_Table::tab_cell_nav | ( |  | ) | const
| inline

Get state of table's 'Tab' key cell navigation flag.

Returns
  1 if Tab configured to navigate cells in table
  0 to navigate widget focus (default)

See also
  tab_cell_nav(int)

## ◆ tab_cell_nav() [2/2]

void Fl_Table::tab_cell_nav | ( | int | val | ) |
| inline

Flag to control if Tab navigates table cells or not.

If on, Tab key navigates table cells. If off, Tab key navigates fltk widget focus. (default)

As of fltk 1.3, the default behavior of the Tab key is to navigate focus off of the current widget, and on to the next one. But in some applications, it's useful for Tab to be used to navigate cells in the Fl_Table.

Parameters

  [in] | val | If `val` is 1, Tab key navigates cells in table, not fltk widgets. If `val` is 0, Tab key will advance focus to the next fltk widget (default), and does not navigate cells in table.

## ◆ table_box()

void Fl_Table::table_box | ( | Fl_Boxtype | val | ) |
| inline

Sets the kind of box drawn around the data table, the default being FL_NO_BOX.

Changing this value will cause the table to redraw.

## ◆ table_resized()

void Fl_Table::table_resized | ( |  | ) |
| protected

Call this if table was resized, to recalculate internal data.

Calls recall_dimensions(), and recalculates scrollbar sizes.

## ◆ table_scrolled()

void Fl_Table::table_scrolled | ( |  | ) |
| protected

Recalculate internals after a scroll.

Call this if table has been scrolled or resized. Does not handle redraw(). TODO: Assumes ti[xywh] has already been recalculated.

## ◆ top_row() [1/2]

int Fl_Table::top_row | ( |  | ) |
| inline

Returns the current top row shown in the table.

This row may be partially obscured.

## ◆ top_row() [2/2]

void Fl_Table::top_row | ( | int | row | ) |
| inline

Sets which row should be at the top of the table, scrolling as necessary, and the table is redrawn.

If the table cannot be scrolled that far, it is scrolled as far as possible.

## ◆ visible_cells()

void Fl_Table::visible_cells | ( | int & | r1,
|  | int & | r2,
|  | int & | c1,
|  | int & | c2 )
| inline

Returns the range of row and column numbers for all visible and partially visible cells in the table.

These values can be used e.g. by your draw_cell() routine during CONTEXT_STARTPAGE to figure out what cells are about to be redrawn for the purposes of locking the data from a database before it's drawn.

leftcol rightcol
: :
toprow .. .-------------------.
| |
| V I S I B L E |
| |
| T A B L E |
| |
botrow .. '-------------------`
Fl_Table::botrow
int botrow
bottom row# of currently visible table on screen
Definition Fl_Table.H:213
Fl_Table::rightcol
int rightcol
right column# of currently visible table on screen
Definition Fl_Table.H:215
Fl_Table::leftcol
int leftcol
left column# of currently visible table on screen
Definition Fl_Table.H:214
Fl_Table::toprow
int toprow
top row# of currently visible table on screen
Definition Fl_Table.H:212

e.g. in a table where the visible rows are 5-20, and the visible columns are 100-120, then those variables would be:

- toprow = 5
- botrow = 20
- leftcol = 100
- rightcol = 120

## ◆ when()

void Fl_Table::when | ( | Fl_When | flags | ) |

The Fl_Widget::when() function is used to set a group of flags, determining when the widget callback is called:

`FL_WHEN_CHANGED` | callback() will be called when rows or columns are resized (interactively or via col_width() or row_height()), passing CONTEXT_RC_RESIZE via callback_context().
`FL_WHEN_RELEASE` | callback() will be called during FL_RELEASE events, such as when someone releases a mouse button somewhere on the table.

The callback() routine is sent a TableContext that indicates the context the event occurred in, such as in a cell, in a header, or elsewhere on the table. When an event occurs in a cell or header, callback_row() and callback_col() can be used to determine the row and column. The callback can also look at the regular fltk event values (ie. Fl::event() and Fl::event_button()) to determine what kind of event is occurring.

The documentation for this class was generated from the following files:

- Fl_Table.H
- Fl_Table.cxx